<template>
    <div>
        <q-list bordered class="rounded-borders" v-for="(chatroom, index) in chatrooms" :key="chatroom.id">
            
            <q-expansion-item :default-opened="defopen" class="bg-accent text-positive" group="somegroup" @click="setCurrentOpenChat(chatroom.id)" @after-show="initscroll(index)" :ref="`expansionitem${chatroom.id}`" @keyup.enter.stop="stop"><!--v-model="open"-->
                <template v-slot:header >
                    <!--<q-item-section avatar>
                        <q-avatar icon="bluetooth" color="primary" text-color="white" />
                    </q-item-section>-->

                    <q-item-section>
                        {{chatroom.name}}
                    </q-item-section>

                    <q-item-section side>
                        {{chatroom.id}}
                    </q-item-section>
                </template>

                <q-card class="text-positive">

                    <q-card-section class="bg-positive">
                        <div class="q-pa-md row justify-center" >
                            <div style="width: 100%; max-width: 600px; height: 400px;">
                                <q-scroll-area :ref="`scrollArea${chatroom.id}`" style="height: 100%; width: 100%;">

                                    <q-chat-message label="Sunday, 19th"/>

                                    <div v-for="message in chatroom.messages" v-bind:key="message.id">
                                        <q-chat-message v-if="message.email == 'weasel@tutamail.com'"
                                            :key = "message.id"
                                            :name = "message.email"
                                            avatar = "~assets/MarkPassFoto.jpg"
                                            :text = "[message.message]"
                                            text-sanitize
                                            :sent = "message.email == oidcUser.email ? true : false"
                                            :stamp = "message.creationdate"
                                        />
                                        <q-chat-message v-else
                                            :key = "message.id"
                                            :name = "message.email"
                                            :avatar = "`${gateway}/api/img/image/${message.email}`"
                                            :text = "[message.message]"
                                            text-sanitize
                                            :sent = "message.email == oidcUser.email ? true : false"
                                            :stamp = "message.creationdate"
                                        />
                                    </div>
                                    
                                    
                                </q-scroll-area>
                            </div>
                        </div>
                    </q-card-section>

                    <q-separator />

                    <q-card-section class="bg-accent">
                        <q-form @submit="onSubmit(index)" :ref="`form${index}`"><!--:ref="`txt${index}`"-->
                            <div class="row">
                                <div class="col-11 p-a-sm">
                                    <q-input clearable filled label="your message" dark :ref="`input${index}`" v-model="text[index]"><!--lazy-rules :rules="[ val => val && val.length > 0 || 'Please type something']" v-on:input="setText($event, index)" :value="getText(index)"-->
                                        <template v-slot:before>
                                            <!-- <q-avatar>
                                                <q-icon color="white" name="fas fa-user" />
                                            </q-avatar> -->
                                        </template>
                                    </q-input>
                                </div>
                                <div class="col-1 p-a-sm">
                                    <q-btn round flat color="secondary" icon="send" type="submit"></q-btn>
                                </div>
                            </div>
                        </q-form>
                    </q-card-section>
                </q-card>
            </q-expansion-item>

            <q-separator />
            
        </q-list>
    </div>
</template>

<script>
import { gateway_url } from "src/assets/custom";
export default {
    name: 'Chat',
    data () {
        return {
            text: [],
            scrollstate: [],
            gateway: gateway_url 
        }
    },
    async beforeMount(){
        for (var i = 0; i < this.$store.state.chat.chats.length; i++){
            this.text.push('');
            this.scrollstate.push(false);
        }
    },
    methods: {
        async onSubmit(index){
            if( this.text[index] != ''){
                let newMessage =
                    {
                        id: null,
                        message: this.text[index],
                        chatroom_id: this.$store.state.chat.currentOpenChat,
                        creationdate: null,
                        email: this.oidcUser.email,
                    };
                await this.$store.dispatch( 'chat/postMessage', newMessage );
                // Reset textfield
                this.text[index]='';
                // focus textfield
                this.$refs[`input${index}`][0].focus();
                //const form = this.$refs[`form${index}`];
                //console.log("Form: " + form);

                // Refresh PersonWebDTO
                //await this.$store.dispatch('chat/requestPersonWebDTO' );
                await this.$store.dispatch('chat/chatsByEmail');
                
                // Scroll Chat down to last message after PersonWebDTO reloaded and new message appeared
                this.scroll();
                
                //event.target.submit();
            }
        },
        initscroll(index){
            if( this.scrollstate[index] === false ){
                this.scroll();
                this.scrollstate[index] = true;
            }
            // Set cursor into chat ready to write
            this.$refs[`input${index}`][0].focus();
        },
        scroll() {
            const scrollArea = this.$refs[`scrollArea${this.$store.state.chat.currentOpenChat}`][0];
            const scrollTarget = scrollArea.getScrollTarget();
            const duration = 300; // ms - use 0 to instant scroll
            scrollArea.setScrollPosition(scrollTarget.scrollHeight, duration);
        },
        setCurrentOpenChat(chatId){
            this.$store.dispatch('chat/setCurrentOpenChat', chatId);
        },
    },
    computed: {
        oidcUser: function(){
            return this.$store.state.oidcUser.oidcUser;      
        },
        chatrooms: function(){
            return this.$store.state.chat.chats;
        },
        defopen(){
            return this.$store.state.chat.chats.length<2  ? false:false
        },
    },
}
</script>